<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="120px">
      <el-row align="left">
        <el-col :span="5">
          <el-form-item label-width="120px" label="预审状态" prop="checkstatus" style="float: left">
            <el-select v-model="queryParams.checkstatus" placeholder="请选择" style="width: 100%">
              <el-option v-for="item in checkmaterials" :key="item.value" :label="item.label" :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="5">
          <el-form-item label="审批状态" prop="CHECKFLAG" style="float: left">
            <el-select v-model="queryParams.CHECKFLAG" placeholder="请选择" style="width: 100%">
              <el-option v-for="item in checkFlagOptions" :key="item.value" :label="item.label" :value="item.value">
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="5">
          <el-form-item label="经办人" prop="name">
            <el-input v-model="queryParams.name" placeholder="请输入经办人" clearable size="small"
              @keyup.enter.native="flowconclusion" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="5">
          <el-form-item label="报销金额" prop="money" style="float: left">
            <el-input v-model="queryParams.money" placeholder="请输入申请人金额" clearable size="small"
              @keyup.enter.native="flowconclusion" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="申请日期" prop="createTime">
            <el-date-picker format="yyyy-MM-dd" @change="selectapplication" value-format="yyyy-MM-dd" v-model="createTime"
              type="daterange" range-separator="至" start-placeholder="申请开始日期" end-placeholder="申请结束日期"
              @keyup.enter.native="flowconclusion">
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <div style="margin-bottom: 15px;">
            <el-button type="primary" icon="el-icon-search" size="mini" @click="flowconclusion">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </div>
        </el-col>
      </el-row>
    </el-form>
    <el-form ref="infoform" label-width="100px">
      <el-row>
        <el-table v-loading="loading" border :data="donateconsolationfundList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="45"> </el-table-column>
          <el-table-column label="个税计算情况" align="center" prop="recordstatus" width="200">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_tax" :value="scope.row.istax" />
            </template>
          </el-table-column>
          <el-table-column label="申请日期" width="180" align="center" prop="applyTime">
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.applyTime, "{y}-{m}-{d}") }}</span>
            </template>
          </el-table-column>
          <el-table-column label="经办人" align="center" prop="username" width="150px" />
          <el-table-column label="申请金额" align="center" prop="pretaxcost" width="200px" />
          <el-table-column label="绩效类型" width="150" align="center" prop="Performancetype">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_performance_type" :value="scope.row.Performancetype" />
            </template>
          </el-table-column>
          <el-table-column label="审核状态" align="center" prop="recordstatus" width="200">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_recordstatus" :value="scope.row.recordstatus" />
            </template>
          </el-table-column>
          <el-table-column label="申请材料状态" width="140" align="center" prop="checkstatus">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.sys_stage_type" :value="scope.row.checkstatus" />
            </template>
          </el-table-column>
          <el-table-column label="备注" align="center" prop="remark" />
          <el-table-column label="操作" fixed="right" align="center" class-name="small-padding fixed-width" width="260px">
            <template slot-scope="scope">
              <el-button size="mini" type="text" icon="el-icon-edit" v-if="scope.row.checkFlag == 0"
                @click="handleDetail(scope.row)">详情</el-button>

              <el-button v-if="scope.row.checkFlag == 1" size="mini" type="text" icon="el-icon-edit"
                @click="handleCheck(scope.row)">审核</el-button>
              <!-- v-hasPermi="['project:donateconsolationfund:edit']" -->
              <el-button size="mini" type="text" icon="el-icon-download" @click="totaldayin(scope.row.id)"
                v-hasPermi="['project:donateconsolationfund:download']">下载</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
          @pagination="getlistbypower" />
      </el-row>
    </el-form>
  </div>
</template>

<script>
import {
  onelistFund,
  listFund,
  getFund,
  delFund,
  addFund,
  updateFund,
  exportFund,
  getdownloadLW,
  getdownloadSH,
  getdownloadSS,
  getdownloadYX,
  getdownloadBX,
  checkfund,
  listbypower,
  getdetailsByItemId,
  addFundSharedInfo
} from "@/api/project/fund";
import {
  onelistFunds,
  listFunddetails,
  listFunddetail,
  getFunddetail,
  delFunddetail,
  addFunddetail,
  getownFundDetail,
  updateFunddetail,
  exportFunddetail,
  getItemNames,
  getFundType,
  getFundTypeAll,
  listcountItem
} from "@/api/project/funddetail";
import {
  listOrganization,
  getOrganization,
  listReportname,
  listUser
} from "@/api/project/organization";
import {
  listFundflow,
  getFundflow,
  delFundflow,
  addFundflow,
  updateFundflow,
  exportFundflow
} from "@/api/project/fundflow";

import {
  listExternalperson,
  getExternalperson,
  getInfoBytheUserNo,
  delExternalperson,
  addExternalperson,
  updateExternalperson,
  exportExternalperson
} from "@/api/project/externalperson";
import {
  listDonatebaseinfo,
  getDonatebaseinfo
} from "@/api/project/donatebaseinfo";
import Li_area_select from "@/components/Address";
import OrgSelecter from "@/views/project/components/orgselect";
import { getUserProfile } from "@/api/system/user";
import { getToken } from "@/utils/auth";
import { setItem, grtItem, removeItem } from "@/utils/storage.js";

export default {
  components: {
    Li_area_select,
    OrgSelecter
  },
  name: "Donateconsolationfund",
  dicts: [
    "sys_recordstatus",
    "sys_OrganizationType",
    "sys_DonationStatus",
    "sys_depositbank",
    "sys_FamilyRelation",
    "sys_IDType",
    "sys_ConsolationType",
    "sys_fund_type",
    "sys_finsubject",
    "sys_financeitemtype",
    "sys_consolationfundlevel",
    "sys_stage_type",
    "sys_performance_type",
    "sys_tax"
  ],
  data() {
    return {
      arrr2: [],
      arrr3: [],
      //费用类型数组
      fundtypeArr: [],
      show: 0,
      createTime: [],
      newobj: {
        flowlevelone: null,
        flowconclusion: null,
        fundid: null
      },
      showFirstapprovelevel: false,
      showSecondapprovelevel: false,
      showThirdapprovelevel: false,
      bankprovince: {
        sheng: "",
        shi: "",
        qu: "",
        organizationname: null
      },
      openbtn: true,
      isopen: 0,
      istrue: 1,
      reporters: [],
      lunlilaowu: [],
      arrid: [],
      a: "",
      idss: "",
      updatedatas: {},
      //当前选中捐献者姓名
      curdonordoname: "",
      //当前选中捐献者案例编号
      curdonorno: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 捐献人道慰问金表格数据
      donateconsolationfundList: [],
      // 弹出层标题
      title: "",
      //捐献案例列表数据
      // donationCaseTableData:[],
      donatebaseinfoList: [],

      // 是否显示弹出层
      open: false,
      checkFlagOptions: [
        {
          value: 0,
          label: "已审批"
        },
        {
          value: 1,
          label: "待审批"
        },
        {
          value: 2,
          label: "全部"
        }
      ],
      checkmaterials: [
        {
          value: 1,
          label: "材料待审核"
        },
        {
          value: 2,
          label: "审查通过等待邮寄纸质材料"
        },
        {
          value: 3,
          label: "已收到纸质材料"
        }
      ],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        APPLICANT: null,
        APPLICATIONBEGTIME: null,
        APPLICATIONENDTIME: null,
        CHECKFLAG: 1,
        APPLYTYPE: 5,
        money: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        username: [
          { required: true, message: "请输入申请人姓名", trigger: "blur" }
        ],
        createTime: [
          { required: true, message: "请输入申请日期", trigger: "blur" }
        ],
        amountrequested: [
          { required: true, message: "请输入申请金额", trigger: "blur" }
        ]
      },
      //当前选中捐献案例
      curCase: {},
      //是否显示费用申请弹窗
      dialogOpen: false,
      // title: "",
      //费用申请表单title
      applyFormTitle: "",
      //费用申请单form
      applicationForm: {},
      fundDetailArr: [],
      fundflowList: [],
      organspeciallist: [],
      yitibody: [],
      donoryixue: [],
      jiashumoney: [],
      itemArr: [],
      allnum: [],
      userlist: [],
      approveLevel: 5,
      fundtypeArrAll: [],
      dialogType: "edit",

      //附件列表
      fileList: [],
      //上传附件路径
      uploadFileUrl: process.env.VUE_APP_BASE_API + "/common/upload",
      headers: {
        Authorization: "Bearer " + getToken()
      }
    };
  },
  watch: {},
  created() {
    this.resetForm();
    this.getUsermsg();
  },

  mounted() {
    if (grtItem("performanceCheck")) {
      this.queryParams = grtItem("performanceCheck");
      this.queryParams.APPLICATIONBEGTIME = "";
      this.queryParams.APPLICATIONENDTIME = "";
    }
    this.getlistOrganization();
    //his.getlistUser();
    this.getlistbypower();
  },

  methods: {
    selectapplication() {
      this.queryParams.APPLICATIONBEGTIME = this.createTime[0];
      this.queryParams.APPLICATIONENDTIME = this.createTime[1];
    },
    getlistbypower() {
      this.loading = true;
      // this.queryParams.params = {};
      console.log("this.queryParams", this.queryParams);
      listbypower(this.queryParams).then(res => {
        removeItem("performanceCheck");
        setItem("performanceCheck", this.queryParams);
        this.loading = false;
        let list = res.rows;
        this.total = res.total;
        this.donateconsolationfundList = list;
      });
    },
    getlistOrganization() {
      listOrganization().then(res => { });
    },

    totaldayin(e) {
      // const id =this.row.id
      getdownloadBX(e).then(res => {
        var fileUrl = res;
        //获取当前网址
        var urlBase = process.env.VUE_APP_BASE_API;
        var curWWWPath = window.document.location.href;
        var pos = curWWWPath.indexOf(window.document.location.pathname);
        // 创建a标签
        var aEle = document.createElement("a");
        aEle.href =
          curWWWPath.substring(0, pos) + urlBase + fileUrl["downloadUrl"];
        console.log(aEle.href);
        // 添加Authorization头部
        fetch(aEle.href, {
          headers: this.headers
        })
          .then(response => {
            // 将文件下载链接作为blob对象进行下载
            return response.blob();
          })
          .then(blob => {
            const url = window.URL.createObjectURL(new Blob([blob]));
            console.log(url);
            const link = document.createElement("a");
            link.href = url;
            const name=fileUrl["downloadName"]
            link.setAttribute("download", name); // 替换file.pdf为实际的文件名
            document.body.appendChild(link);
            link.click();
            link.parentNode.removeChild(link);
          });
      });
    },

    isopenvalue(index) {
      this.isopen = index;
    },

    tojust(e) {
      let username = "111";
      getFund(e).then(res => {
        username = res.data.username;
        this.$modal
          .confirm('是否确认通过"' + username + '"的费用申请？')
          .then(function () {
            getFund(e).then(res => {
              let data = res.data;
              let financechecher = "已审核";
              data.financechecher = financechecher;
              // data.recordstatus = "部门已通过";
              const username = data.username;
              return updateFund(data);
            });
          })
          .then(() => {
            this.getList();
            this.getlistbypower();
            this.$modal.msgSuccess("审核成功");
          });
      });
    },
    /** 搜索按钮操作 */
    flowconclusion() {
      this.queryParams.pageNum = 1;
      this.getlistbypower();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeReporttime = [];
      this.resetForm("queryForm");
      this.getlistbypower();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    beforehandCheck(row) {
      this.$router.push({
        path: "/finance/performancedetails/",
        query: {
          id: row.id,
          businessType: "5",
          beforehandType: "1",
          operationType: "check"
        }
      });
    },
    /** 审核按钮操作 */
    handleCheck(row) {
      this.$router.push({
        path: "/finance/performancedetails/",
        query: {
          id: row.id,
          businessType: "5",
          operationType: "check"
        }
      });
      return;
    },

    //查看审核详情
    handleDetail(row) {
      this.$router.push({
        path: "/finance/performancedetails/",
        query: {
          id: row.id,
          businessType: "5",
          operationType: "detail"
        }
      });
      return;
    },
    getto() {
      const infoid = this.curCase.id;
      const aaa = {
        infoid: infoid,
        count: this.idss
      };
      listFunddetails(aaa).then(res => { });
    },
    getUsermsg() {
      getUserProfile().then(response => {
        // this.defaultperson = response.data;
        // this.standardlevel = response.data.standardlevel;
        if (
          response.data.userName === "053" ||
          response.data.userName === "002" ||
          response.data.userName === "admin"
        ) {
          this.show = 1;
        } else {
          this.show = 3;
        }
      });
    }
  }
};
</script>
